package communication;


import userinterface.MainActivity;
import android.content.Context;
import android.os.Bundle;
import android.util.Log;

import com.wahoofitness.api.WFAntException;
import com.wahoofitness.api.WFAntNotSupportedException;
import com.wahoofitness.api.WFAntServiceNotInstalledException;
import com.wahoofitness.api.WFDisplaySettings;
import com.wahoofitness.api.WFHardwareConnector;
import com.wahoofitness.api.WFHardwareConnectorTypes.WFAntError;
import com.wahoofitness.api.WFHardwareConnectorTypes.WFHardwareState;
import com.wahoofitness.api.comm.WFSensorConnection;




public class WF_Communication implements I_Communication,WFHardwareConnector.Callback{

	private WFHardwareConnector mHardwareConnector;
	private static final String TAG = "Roue";
	private CapteurWFBikeCadence sensor;
	
	//Activite 
	private MainActivity activity;
	private Bundle save;
	
	public WF_Communication(MainActivity act, Bundle saved){
		activity = act ;
		save = saved ;
	}
	
    // WFHardwareConnector.Callback Implementation
 @Override
     public void hwConnAntError(WFAntError error) {
             switch (error) {
                     case WF_ANT_ERROR_CLAIM_FAILED:
                     //mAntStateText.setVisibility(TextView.VISIBLE);
                     //mAntStateText.setText("ANT radio in use.");
                             //mHardwareConnector.forceAntConnection(getResources().getString(R.string.app_name));
                             break;
             }
     }
    
@Override
     public void hwConnConnectionRestored() {
     //mBikeCadence.restoreConnectionState();
 }

     @Override
     public void hwConnConnectedSensor(WFSensorConnection sensorConnection) {
//           mTextDevId.setText(Integer.toString(sensorConnection.getDeviceNumber()));
     }

     @Override
     public void hwConnDisconnectedSensor(WFSensorConnection sensorConnection) {
            
     }
     /**
      * 
      * @param state
      * @param context
      */
     public void hwConnStateChanged(WFHardwareState state, Context context) {
             switch (state) {
                     case WF_HARDWARE_STATE_DISABLED:
                     //mAntStateText.setVisibility(TextView.VISIBLE);
                     if (WFHardwareConnector.hasAntSupport(context)) {
                             //mAntStateText.setText("HW Connector DISABLED.");
                     }
                     else {
                             //mAntStateText.setText("ANT Radio NOT supported.");
                     }
                             break;
                            
                     case WF_HARDWARE_STATE_SERVICE_NOT_INSTALLED:
                     //mAntStateText.setVisibility(TextView.VISIBLE);
                     //mAntStateText.setText("ANT Radio Service NOT installed.");
                             break;
                            
                     case WF_HARDWARE_STATE_SUSPENDED:
                     //mAntStateText.setVisibility(TextView.VISIBLE);
                     //mAntStateText.setText("HW Connector SUSPENDED.");
                     break;
                    
                     case WF_HARDWARE_STATE_READY:
                     default:
                     //mAntStateText.setVisibility(TextView.INVISIBLE);
                             break;
             }
     }

    
    ///////////////////////////////////////////////////////////////////////////
	//
	/**
	 * 
	 */
	public void initControls(){
		
		sensor = new CapteurWFBikeCadence(activity, save);
		sensor.initControl(mHardwareConnector);
		//activity.alert( "Info" ,"ANT initialization OK");
	}
	  /**
	   * 
	   * @param context
	   * @param savedInstanceState
	   */
	public void antConnect(Context context,Bundle savedInstanceState)
    {
            if (WFHardwareConnector.hasAntSupport(context)) {
           
            try {
                    boolean bResumed = false;
                   
                    // attempt to retrieve the previously suspended WFHardwareConnector instance.
                    //
                    // see the onRetainNonConfigurationInstance method.
                    mHardwareConnector = (WFHardwareConnector)activity.getLastNonConfigurationInstance();
                    if (mHardwareConnector != null) {
                            // attempt to resume the WFHardwareConnector instance.
                            if (!(bResumed = mHardwareConnector.resume(this))) {
                                    // if the WFHardwareConnector instance failed to resume,
                                    // it must be re-initialized.
                                    mHardwareConnector.connectAnt();
                            }
                    }
                   
                    // if there is no suspended WFHardwareConnector instance,
                    // configure the singleton instance.
                    else {
                             // get the hardware connector singleton instance.
                            mHardwareConnector = WFHardwareConnector.getInstance(activity, this);
                                    mHardwareConnector.connectAnt();
                    }
                   
                    // restore connection state only if the previous
                    // WFHardwareConnector instance was not resumed.
                    if (!bResumed) {
                            // the connection state is cached in the state
                            // bundle (onSaveInstanceState).  this is used to
                            // restore previous connections.  if the Bundle
                            // is null, no connections are configured.
                            mHardwareConnector.restoreInstanceState(savedInstanceState);
                    }
                   
                    // configure the display settings.
                    //
                    // this demonstrates how to use the display
                    // settings.  if this step is skipped, the
                    // default settings will be used.
                    WFDisplaySettings settings = mHardwareConnector.getDisplaySettings();
                    settings.staleDataTimeout = 5.0f;          // seconds, default = 5
                    settings.staleDataString = "--";           // string to display when data is stale, default = "--"
                    settings.useMetricUnits = true;            // display metric units, default = false
                    settings.bikeWheelCircumference = 2.07f;   // meters, default = 2.07
                    settings.bikeCoastingTimeout = 3.0f;       // seconds, default = 3    
                    mHardwareConnector.setDisplaySettings(settings);
                   
                   
            }
            catch (WFAntNotSupportedException nse) {
                    // ANT hardware not supported.                          
                    activity.alert("Erreur","ANT not supported.");
            }
            catch (WFAntServiceNotInstalledException nie) {

                            //Toast installNotification = Toast.makeText(context, this.getResources().getString( R.string.Notify_Service_Required), Toast.LENGTH_LONG);
                            //installNotification.show();

                            // open the Market Place app, search for the ANT Radio service.
                            mHardwareConnector.destroy();
                            mHardwareConnector = null;
                            WFHardwareConnector.installAntService(context);

                            // close this app.
                            activity.finish();
            }
                    catch (WFAntException e) {
                           
                            activity.alert( "Erreur" ,"ANT initialization error.");
                    }
   }
    else {
            // ANT hardware not supported.                  
            activity.alert("Erreur" ,"ANT not supported.");
    }
   
    if(!activity.isFinishing())
    {
        //setContentView(R.layout.landscape_grid);
        initControls();
            //mAntStateText.setVisibility(statusVisibility);
            //mAntStateText.setText(statusText);
    }
    }

	    
	    /**
	     * 
	     */
	public void hwConnHasData() {
		//Log.d(TAG, "hwConnHasData");
		sensor.connectSensor();
		//activity.alert("Info", ""+sensor.getTour());
	}
	/**
	 * 
	 */
	public void hwConnStateChanged(WFHardwareState arg0) {
		// TODO Auto-generated method stub		
	}

	@Override
	public void init() {
		this.initControls();
		this.antConnect(this.activity.getApplicationContext(), this.save);
		
	}

	@Override
	public void start() {
		Log.d("Ant","Start Method");
		sensor.connectSensor();
	}

	@Override
	public void finish() {
		mHardwareConnector.hwControllerAntDisconnected();
		sensor.disconnectSensor();

		
	}

	@Override
	public int getTour() {
		return sensor.getTour();

	}
}