package userinterface;

import mesure.Coordonnee;
import android.app.AlertDialog;
import android.app.Fragment;
import android.content.DialogInterface;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.text.InputType;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.engine.Engine;
import com.engine.R;
import com.engine.R.drawable;
import com.engine.R.id;
import com.engine.R.layout;
import com.mapquest.android.maps.AnnotationView;
import com.mapquest.android.maps.DefaultItemizedOverlay;
import com.mapquest.android.maps.GeoPoint;
import com.mapquest.android.maps.ItemizedOverlay;
import com.mapquest.android.maps.MapController;
import com.mapquest.android.maps.MapView;
import com.mapquest.android.maps.OverlayItem;


public class F_MAP extends Fragment{
	
	protected MapView map; 
	private MapController myMapController;
	private String name ;
	private int id;
	private Engine e ;
	private AnnotationView annotation;
	private DefaultItemizedOverlay overlay;
	public F_MAP(String name,int id,Engine en) {
		
		this.name = name;
		this.id = id;
		e = en;	

	}

    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
    	
        View v = inflater.inflate(R.layout.f_map, container, false);
        Drawable icon = e.getMainActivity().getResources().getDrawable(R.drawable.location_marker);
    	overlay = e.getMainActivity().getOverlay();
        map = (MapView)v.findViewById(R.id.map);
        map.setBuiltInZoomControls(true);
        myMapController = map.getController();
        if(e.getMainActivity().getSavedNode().size()>0)
        {
			Coordonnee c = e.getMainActivity().getSavedNode().get( e.getMainActivity().getSavedNode().size()-1).getCoordonnee();
			GeoPoint geo = new GeoPoint(c.get_lat(),c.get_long());
			map.getController().setCenter(geo);
	        setupMapView(geo, 17,v);
		}else
		{
			GeoPoint geo = new GeoPoint(45.184508,5.753154);
			map.getController().setCenter(geo);
	        setupMapView(geo, 17,v);	
		}

        Button go = (Button)v.findViewById(R.id.go);
        go.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	if(overlay.size()>0)
            		getDialogText("Nom du premier point");
            	
            }
        });
		



        // initialize the annotation to be shown later 
    	annotation = new AnnotationView(map);
    	// add an onclick listener to the annotationView
    	annotation.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Toast.makeText(map.getContext(), 
						"Clicked the "+annotation.getOverlayItem().getTitle()+" annotation", 
						Toast.LENGTH_SHORT).show();
			}
		});

    	
    	// add a tap listener
    	overlay.setTapListener(new ItemizedOverlay.OverlayTapListener() {
			@Override
			public void onTap(GeoPoint pt, MapView mapView) {
				// when tapped, show the annotation for the overlayItem
				int lastTouchedIndex = overlay.getLastFocusedIndex();
				if(lastTouchedIndex>-1){
					OverlayItem tapped = overlay.getItem(lastTouchedIndex);
					annotation.showAnnotationView(tapped);
				}
			}
		});
    
    	map.getOverlays().add(overlay);
		
    	return v;
    }

    protected void setupMapView(GeoPoint pt, int zoom , View v) {
    	
		this.map = (MapView) v.findViewById(R.id.map);

		// set the zoom level
		map.getController().setZoom(zoom);
		
		// set the center point
		map.getController().setCenter(pt);
		
		// enable the zoom controls
		map.setBuiltInZoomControls(true);
		
		map.getOverlays().add(new MapOverlay(e,overlay));
    }
    /**
     * 
     * @return the fragment's name
     */
    public String getName() {
		return name;
    }
    
    /**
     * 
     * @param text
     */
    private void addEventText(String text){
		e.getMainActivity().alert("Event",text);
		
	}
    
    /**
     * Generate a AlerDialog and save the name of point
     * @param title
     */  
private void getDialogText(String title) {
		
		AlertDialog.Builder builder = new AlertDialog.Builder(e.getMainActivity());
    	builder.setTitle(title);

    	// Set up the input
    	final EditText input = new EditText(e.getMainActivity());
    	// Specify the type of input expected; this, for example, sets the input as a password, and will mask the text
    	input.setInputType(InputType.TYPE_CLASS_TEXT);
    	builder.setView(input);

    	// Set up the buttons
    	builder.setPositiveButton("OK", new DialogInterface.OnClickListener() { 
    	    @Override
    	    public void onClick(DialogInterface dialog, int which) {
    	    	OverlayItem overlayuser = e.getMainActivity().getOverlay().getItem(e.getMainActivity().getOverlay().size()-1);
    	    	e.getMainActivity().getOverlay().clear();
    	    	e.getMainActivity().getOverlay().addItem(overlayuser);
    	    	overlayuser.setTitle(input.getText().toString());
            	GeoPoint userlast = overlayuser.getPoint();
            	e.init(new Coordonnee( userlast.getLatitude() , userlast.getLongitude()),  input.getText().toString());
    	       	return;
    	    }
    	});
    	builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
    	    @Override
    	    public void onClick(DialogInterface dialog, int which) {
    	        dialog.cancel();
    	        return;
    	    }
    	});
    	builder.create();
    	builder.show();

}
    
}
