package userinterface;

import mesure.Coordonnee;

import com.engine.Engine;
import com.engine.R;
import com.engine.R.id;
import com.engine.R.layout;
import com.mapquest.android.maps.AnnotationView;
import com.mapquest.android.maps.DefaultItemizedOverlay;
import com.mapquest.android.maps.GeoPoint;
import com.mapquest.android.maps.ItemizedOverlay;
import com.mapquest.android.maps.MapController;
import com.mapquest.android.maps.MapView;
import com.mapquest.android.maps.MyLocationOverlay;
import com.mapquest.android.maps.OverlayItem;


import android.annotation.SuppressLint;
import android.app.Fragment;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.os.storage.StorageManager;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

@SuppressLint("ValidFragment")
public class F_Mesure extends Fragment {

	private String name ;
	private int id;
	 
	private Engine e ;
	private Button start;
	private Button stop ;
	private Button poi ;
	private AnnotationView annotation;
	private DefaultItemizedOverlay overlay;
	protected MapView map; 
	private com.mapquest.android.maps.MapController myMapController;
	public F_Mesure(String name,int id,Engine en) {
		
		this.name = name;
		this.id = id;
		e = en;	
		
	}

    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
    	
        View v = inflater.inflate(R.layout.f_mesure, container, false);
        TextView boussole = (TextView)v.findViewById(R.id.Textboussole);

        
    	overlay = e.getMainActivity().getOverlay();
        map = (MapView)v.findViewById(R.id.map);
        map.setBuiltInZoomControls(true);
        myMapController = map.getController();
        myMapController.setZoom(11);
        MyLocationOverlay location = new MyLocationOverlay(getActivity(), map);
        location.enableCompass();
        setupMapView( new GeoPoint(45.184508,5.753154), 17,v);
        map.getOverlays().add(overlay);
        map.getOverlays().add(location);
    	Coordonnee c = e.getInitialPoint();
    	if (c!=null){
        	map.getController().setCenter(new GeoPoint(c.get_lat(),c.get_long()));
    	}
    	else
    	{
    		c = e.getMainActivity().getSavedNode().get(e.getMainActivity().getSavedNode().size()-1).getCoordonnee();
    		map.getController().setCenter(new GeoPoint(c.get_lat(),c.get_long()));
    		
    	}
        // initialize the annotation to be shown later 
    	annotation = new AnnotationView(map);
    	// add an onclick listener to the annotationView
    	annotation.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Toast.makeText(map.getContext(), 
						"Clicked the "+annotation.getOverlayItem().getTitle()+" annotation", 
						Toast.LENGTH_SHORT).show();
			}
		});

    	
    	// add a tap listener
    	overlay.setTapListener(new ItemizedOverlay.OverlayTapListener() {
			@Override
			public void onTap(GeoPoint pt, MapView mapView) {
				// when tapped, show the annotation for the overlayItem
				int lastTouchedIndex = overlay.getLastFocusedIndex();
				if(lastTouchedIndex>-1){
					OverlayItem tapped = overlay.getItem(lastTouchedIndex);
					annotation.showAnnotationView(tapped);
				}
			}
		});
        
        start = (Button)v.findViewById(R.id.start);
        stop = (Button)v.findViewById(R.id.stop);
        poi= (Button)v.findViewById(R.id.poi);
    	start.setEnabled(true);
    	stop.setEnabled(false);
    	poi.setEnabled(false);
		start.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	start.setEnabled(false);
            	stop.setEnabled(true);
            	poi.setEnabled(true);
            	e.start();

            	
            }
        });
		
		
		stop.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	e.stop();
            }
        });
		
		
		poi.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	e.savePOI();
            	
            }
        }); 
		
    	return v;
    }
    
    /**
     * 
     * @return the fragment's name
     */
    public String getName() {
		return name;
    }
    
    /**
     * Initialize the map
     * @param pt
     * @param zoom
     * @param v
     */
    protected void setupMapView(GeoPoint pt, int zoom , View v) {
    	
		this.map = (MapView) v.findViewById(R.id.map);

		// set the zoom level
		map.getController().setZoom(zoom);
		
		// set the center point
		map.getController().setCenter(pt);
		
		// enable the zoom controls
		map.setBuiltInZoomControls(true);
		
		map.getOverlays().add(new MapOverlay(e,overlay));
    }

}
