package userinterface;



import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.xmlpull.v1.XmlPullParserException;

import com.engine.Engine;
import com.engine.R;
import com.engine.R.drawable;
import com.engine.R.id;
import com.engine.R.layout;
import com.engine.R.menu;
import com.mapquest.android.maps.AnnotationView;
import com.mapquest.android.maps.DefaultItemizedOverlay;
import com.mapquest.android.maps.GeoPoint;
import com.mapquest.android.maps.ItemizedOverlay;
import com.mapquest.android.maps.MapController;
import com.mapquest.android.maps.MapView;
import com.mapquest.android.maps.OverlayItem;

import mesure.Coordonnee;
import mesure.NodeP;
import android.annotation.SuppressLint;
import android.app.ActionBar;
import android.app.ActionBar.Tab;
import android.app.ActionBar.TabListener;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.app.FragmentTransaction;
import android.text.InputType;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;


@SuppressLint("ShowToast")
public class MainActivity extends Activity implements TabListener {
	
	private ProgressDialog progressDialog;
	
	private int id_dispo_node = -1;
	private int id_dispo_ways = -1 ;
	private int id_dispo_relation = -1 ;
	private int circonference = 55; //En metre
	private float direction_dep = 0;
	private int nb_aimant = 1;
	private int diametre = 55 ;
	
	
	private SharedPreferences sharedPref;
	private List<NodeP> list_node ;
	private String result = ""; //Valeur de retour d'un dialog EditText
	boolean result_choice = false ;
	private DefaultItemizedOverlay overlay;

    private F_POI fragPOI;
    private F_manual fragManual;
    private F_GPS fragGPS ;
    private F_MAP fragMap;
    private F_Mesure fragMesure;


	
    private Engine e ;

    
    /*
     *  Android Application Methods
     */
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		e = new Engine(this, savedInstanceState);
		init();
	    getWindow().requestFeature(Window.FEATURE_ACTION_BAR);
        
	    setContentView(R.layout.activity_main);
	    
	    Drawable icon = this.getResources().getDrawable(R.drawable.location_marker);
    	setOverlay(new DefaultItemizedOverlay(icon));
        
	    recupValeurMenu("Direction Batiment ()", "direction_dep");
	      
	    AlertDialog.Builder startDialog = new AlertDialog.Builder(this);
	    startDialog.setTitle("Choix");
	    String[] operations = {"Indoor Mode","OutDoorMode"};
	    startDialog.setItems(operations, new DialogInterface.OnClickListener() {
	               public void onClick(DialogInterface dialog, int which) {		            	 
		            	 try {
							setFragment(which);
						} catch (XmlPullParserException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						} catch (IOException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
		           }
		    });

	    startDialog.show();		
    }

    @Override
    public void onBackPressed() {  
    	
    	if(!e.isMeasuring() && !this.getActionBar().isShowing()){
 
        		e.getBouss().stop();
        		swapFrag("Init");


    	}
    	else{

			AlertDialog.Builder builder = new AlertDialog.Builder(this);
	    	builder.setTitle("Attention");
	    	builder.setMessage("En quittant l'application , les mesures en cours seront perdues si elles n'ont pas t sauvegardes\nConfirmez-vous ce choix ?" );
	    	// Set up the buttons
	    	builder.setPositiveButton("OK", new DialogInterface.OnClickListener() { 
	    	    @Override
	    	    public void onClick(DialogInterface dialog, int which) {
	    	    	e.finish();
	    	    	Stop();
	    	    }
	    	});
	    	builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
	    	    @Override
	    	    public void onClick(DialogInterface dialog, int which) {
	    	        dialog.cancel();
	    	    }
	    	});
	    	builder.create();
	    	builder.show();
		
    	}
    }
    @Override
	protected void onPause(){
		super.onPause();
		stop();
	}

	@Override
	protected void onResume(){		
		super.onResume();

	}
	@Override
	protected void onDestroy(){
		stop();
		super.onDestroy();
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	

	public void Stop(){
		stop();
		finish();
	}   

	/**
	 * Sub Menu Item
	 */
	public boolean onOptionsItemSelected(MenuItem item) {
        //On regarde quel item a t cliqu grce  son id et on dclenche une action
        switch (item.getItemId()) {
           case R.id.option:
           	/*if(appstart)
           	{
           		alert("Notification","Les modifications ne seront valables qu'aprs le redemarrage d'une mesure.");
           	}*/
              return true;
           case R.id.nbcaps:
        	   recupValeurMenu("Nombre d'aimants", "nb_aimant");           	
               return true;
           case R.id.diam:
               recupValeurMenu("Diamtre (cm)","circonference");
               return true;
           case R.id.direct:
               recupValeurMenu("Direction Batiment ()","direction_dep");
               return true;
           case R.id.fichier :
        	    e.getParser().export_xml_config(list_node);
        	    e.getParser().export_xml(e.getR());
           		return true;
           case R.id.quitter:
              //Pour fermer l'application il suffit de faire finish()
        	   	stop();
        	  	android.os.Process.killProcess(android.os.Process.myPid());
       	   		
              return true;
        }
        return false;
	 }
	
	/*
	 * Value Management
	 */
	/**
	 * 
	 * @param titre
	 * @param var
	 */
	private void recupValeurMenu(String titre, final String var){    
        
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setTitle(titre);
		final EditText input = new EditText(this);
		input.setInputType(InputType.TYPE_CLASS_NUMBER); 
		
		if(var.equals("nb_aimant"))
		{	
			Log.d("Aimant", "");
			int v = sharedPref.getInt(var, 1);
			input.setText("" + v);
		}else if(var.equals("circonference")){
			int v = sharedPref.getInt(var, 1);
			input.setText("" + v);
		}else if(var.equals("direction_dep")){
			float v = sharedPref.getFloat(var, 1);
			input.setText("" + v);
		}
		
		

		builder.setView(input);
		builder.setPositiveButton("Valider", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {
				SharedPreferences.Editor editor = sharedPref.edit();
				if(var.equals("nb_aimant"))
				{	
					editor.putInt(var, Integer.parseInt(input.getText().toString()));
					nb_aimant = Integer.parseInt(input.getText().toString());
				}else if(var.equals("circonference")){
					editor.putInt(var, Integer.parseInt(input.getText().toString()));
					circonference = Integer.parseInt(input.getText().toString());
				}else if(var.equals("direction_dep")){
					editor.putFloat(var, Float.parseFloat(input.getText().toString()));
					direction_dep = Float.parseFloat(input.getText().toString());
				}
				editor.commit();
			}
		});

		builder.setNegativeButton("Annuler", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {
			// aucune action dans ce cas
			}
		});
		
			builder.create();
			builder.show();

	}
	
    
    /*
     *  Android Fragment and Navigation Methods
     */    
	/**
	 * 
	 * @param which
	 * @throws XmlPullParserException
	 * @throws IOException
	 */
    public void setFragment(int which) throws XmlPullParserException, IOException{
    	
		fragPOI = new F_POI("POI", 1, e);
		fragManual = new F_manual("Manual", 2, e);
		fragMap = new F_MAP("Map",4,e);
		fragMesure = new F_Mesure("Mesure",5,e);
	   getActionBar().setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);
 	   if(which == 0)
 	   {
 		   getActionBar().addTab(getActionBar().newTab().setText(fragMap.getName()).setTabListener(this));
 		   getActionBar().addTab(getActionBar().newTab().setText(fragPOI.getName()).setTabListener(this));
 		   getActionBar().addTab(getActionBar().newTab().setText(fragManual.getName()).setTabListener(this));

 	   }else{
 		  fragGPS = new F_GPS("GPS", 3,e);
 		  getActionBar().addTab(getActionBar().newTab().setText(fragMap.getName()).setTabListener(this));
 		  getActionBar().addTab(getActionBar().newTab().setText(fragPOI.getName()).setTabListener(this));
 		  getActionBar().addTab(getActionBar().newTab().setText(fragGPS.getName()).setTabListener(this));
 		  getActionBar().addTab(getActionBar().newTab().setText(fragManual.getName()).setTabListener(this));
 		  
 	   }    
    }
    
    @Override
    
    public void onTabSelected(Tab tab, android.app.FragmentTransaction ft) {
    
		//Toast.makeText(this, tab.getText() + " selected", Toast.LENGTH_SHORT).show();
		if(tab.getText().equals(fragMap.getName())){
		ft.replace(R.id.fragmentContainer, fragMap);
		}else if(tab.getText().equals(fragPOI.getName())){
			ft.replace(R.id.fragmentContainer, fragPOI);}
		else if(tab.getText().equals(fragManual.getName())){
			ft.replace(R.id.fragmentContainer, fragManual);}
		else if(tab.getText().equals(fragGPS.getName())){	
			ft.replace(R.id.fragmentContainer, fragGPS);}
		else if(tab.getText().equals(fragMesure.getName())){	
			ft.replace(R.id.fragmentContainer, fragMesure);}

    }

    @Override
    public void onTabUnselected(Tab tab, android.app.FragmentTransaction ft) {
    	if(tab.getText().equals(fragPOI.getName())){
    		ft.remove(fragPOI);
    	}else if(tab.getText().equals(fragManual.getName())){
    		ft.remove(fragPOI);
    	}else  if(tab.getText().equals(fragMap.getName())){
    		ft.remove(fragPOI);
    	}else  if(tab.getText().equals(fragGPS.getName())){
    		ft.remove(fragPOI);
    	}else  if(tab.getText().equals(fragMesure.getName())){
    		ft.remove(fragPOI);
    	}
    	
    }

    @Override
    public void onTabReselected(Tab tab, android.app.FragmentTransaction ft) {
    		
    }
    /**
     * Manage the Frangment changement in the Apps
     * Two posibility : 
     * 1) Init to go on the initial choice
     * 2) Mesure to go on mesure fragment
     * @param name
     */
	public void swapFrag(String name) {
		if(getActionBar().isShowing())
		{
		 getActionBar().hide();
		}
		
		
		FragmentTransaction ft = getFragmentManager().beginTransaction();
		if(name.equals("Init"))
		{   getActionBar().show();
			Tab tab = this.getActionBar().getSelectedTab();
			if(tab.getText().equals(fragMap.getName())){
				ft.replace(R.id.fragmentContainer, fragMap);
				}
				else if(tab.getText().equals(fragPOI.getName())){
					ft.replace(R.id.fragmentContainer, fragPOI);}
				else if(tab.getText().equals(fragManual.getName())){
					ft.replace(R.id.fragmentContainer, fragManual);}
				else if(tab.getText().equals(fragGPS.getName())){	
					ft.replace(R.id.fragmentContainer, fragGPS);}
		}
		else if(name.equals("Mesure")){
			ft.replace(R.id.fragmentContainer, fragMesure);
		}
		ft.commit();
		
	}
	
	
    /*
     *  Application manage Methods
     */
	/**
	 * Initialize the id data
	 */
	public void init(){
		sharedPref = this.getPreferences(Context.MODE_PRIVATE);
		id_dispo_node = sharedPref.getInt("id_dispo_node",-1);
		id_dispo_ways = sharedPref.getInt("id_dispo_ways",-1);
		id_dispo_relation = sharedPref.getInt("id_dispo_realation",-1);

		try {
			list_node =e.getParser().import_xml_config();
		} catch (XmlPullParserException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			list_node = null;
			e.printStackTrace();
		} 
	}
	/**
	 * Save the id Data
	 */
	public void stop(){
		SharedPreferences sharedPref = this.getPreferences(Context.MODE_PRIVATE);
		SharedPreferences.Editor editor = sharedPref.edit();
		editor.putInt("id_dispo_node",id_dispo_node );
		editor.putInt("id_dispo_ways",id_dispo_ways );
		editor.putInt("id_dispo_relation",id_dispo_relation );
		editor.commit();
		e.finish();
	}
	
	/**
	 * 
	 * @return id node and decrement
	 */
    public int getId_node(){
    	return id_dispo_node--;
    }
    
	/**
	 * 
	 * @return id ways and decrement
	 */
    public int getId_way(){
    	return id_dispo_ways -- ;
    }
    
	/**
	 * 
	 * @return id relation and decrement
	 */
    public int getId_relation(){
    	return id_dispo_relation--;
    }
    /**
     * 
     * @return the distance per tour
     */
    public double getCirconference(){
    	
    	return ((circonference/nb_aimant) * 0.01);
    }
    /**
     * 
     * @return the initial direction
     */
    public float getdirection_dep(){
    	return direction_dep;
    }
    /**
     * 
     * @return the list of saved node
     */
	public List<NodeP> getSavedNode() {
		return list_node;
	}
	
	/**
	 * Save a node in the save list 
	 * @param np
	 */
	public void saveNode(NodeP np){
		if(!list_node.contains(np))
		{
			list_node.add(np);
		}
	}
	
	
	

    /*
     *  Application Display Methods
     */
    public void alert(String notification,String msg)
    {
        AlertDialog alertDialog = new AlertDialog.Builder(this).create();
        alertDialog.setTitle(notification);
        alertDialog.setMessage(msg);
        alertDialog.setButton("OK", new DialogInterface.OnClickListener() {
           public void onClick(DialogInterface dialog, int which) {
              // aucune action dans ce cas gnrique
           }
        });
        alertDialog.show();
    }
    
    //Affichage de la valeur de boussole
    public void Textboussole(String b){
    	
    	TextView boussole = (TextView)findViewById(R.id.Textboussole);
    	boussole.setText(b);
    }
    
    public void TextDistance(String v){
    	TextView distance = (TextView)findViewById(R.id.distance_view);
    	distance.setText(v);
    }

	/**
	 * @return the overlay
	 */
	public DefaultItemizedOverlay getOverlay() {
		return overlay;
	}

	/**
	 * @param overlay the overlay to set
	 */
	public void setOverlay(DefaultItemizedOverlay overlay) {
		this.overlay = overlay;
	}
	

}
