package userinterface;

import android.graphics.drawable.Drawable;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Toast;

import com.engine.Engine;
import com.mapquest.android.maps.AnnotationView;
import com.mapquest.android.maps.DefaultItemizedOverlay;
import com.mapquest.android.maps.GeoPoint;
import com.mapquest.android.maps.ItemizedOverlay;
import com.mapquest.android.maps.MapView;
import com.mapquest.android.maps.Overlay;
import com.mapquest.android.maps.OverlayItem;


    public class MapOverlay extends Overlay
            {
                    private static final int LONG_PRESS_GAP = 25;
                    private static final int LONG_PRESS_TIME = 1000;
     
                    private float downX;
                    private float downY;
     
                    private float lastX;
                    private float lastY;
                    
                    private Engine e ;
                    private DefaultItemizedOverlay overlay ; 
                    public MapOverlay(Engine en, DefaultItemizedOverlay o){
                    	super();
                    	e = en ;
                    	overlay = o ;

                    			
                    }
                    
                    
                    @Override
                    public boolean onTouchEvent(MotionEvent evt, MapView mapView)
                    {
                            switch (evt.getAction())
                            {
                            case MotionEvent.ACTION_DOWN:
                                    downX = evt.getX();
                                    downY = evt.getY();
                                    break;
     
                            case MotionEvent.ACTION_UP:
                                    if (Math.abs(downX - evt.getX()) < LONG_PRESS_GAP && Math.abs(downY - evt.getY()) < LONG_PRESS_GAP)
                                    {
                                            if (evt.getEventTime() - evt.getDownTime() > LONG_PRESS_TIME)
                                            {
                                                    // This is a long press
                                                    longPress(mapView, evt.getX(), evt.getY());
                                                    return true;
                                            }
                                    }
                                    break;
                            }
     
                            lastX = evt.getX();
                            lastY = evt.getY();
     
                            return super.onTouchEvent(evt, mapView);
                    }
                    /**
                     * 
                     * @param mapView
                     * @param x
                     * @param y
                     */
                    private void longPress(MapView mapView, float x, float y)
                    {
                            GeoPoint posUser = mapView.getProjection().fromPixels((int) x, (int) y);
                           
                        	OverlayItem item1 = new OverlayItem(posUser, "", "");
                        	
                        	overlay.addItem(item1);

                        	mapView.invalidate();
                            Toast.makeText(mapView.getContext(),String.format("Touched at: %f,%f", posUser.getLatitude(), posUser.getLongitude()),Toast.LENGTH_LONG).show();
                    }
                    
                    
                	
            }
